<template>
  <div
      class="min-h-full flex items-center justify-center py-6 px-4 sm:px-6 lg:px-8"
  >
    <div
        class="max-w-lg w-full bg-white p-4 md:px-8 md:py-10 shadow-xl z-index-10"
    >
      <div>
        <h2 class="mt-6 text-center text-3xl font-extrabold text-gray-900">
          Créer mon city-tour
        </h2>
      </div>
      <Vuemik
          :initial-values="roadtrip.cityTour.formValues"
          v-slot="{ values, handleSubmit }"
          :submitWithEnter="false"
          :violations="roadtrip.cityTour.violations"
          :on-submit="roadtrip.submitCityTour"
      >
        <Field
            label="Nom de votre CityTour(optionnel) :"
            component="input"
            type="text"
            name="name"
            @input="roadtrip.setNameUpdated()"
        />
        <CityChoose
            label="Ville"
            name="cityC"
            placeholder="Paris, Marseille, Lyon..."
            :reset="() => roadtrip.resetCityPoints('C', values)"
            :onSelectCity="city => roadtrip.selectCity(city,values,'C')"
        />
        <Field
            label="Nombre de jours"
            component="input"
            type="number"
            name="nbDays"
            min="1"
            :value="values.nbDays"
        />
        <Field
            label="Temps minimun par étape"
            component="input"
            type="time"
            name="minimumDurationByStep"
            :value="values.minimumDurationByStep"
        />
        <NbStepsByDay/>
        <tags-categories-preferences-provider
            :field="values.interests"
            type="POI"
        />
        <tags-categories-preferences-provider
            :field="values.interestsRestaurant"
            type="restaurant"
        />
        <tags-categories-preferences-provider
            :field="values.categoriesHostel"
            type="hostel"
        />

        <Field
            component="input"
            type="button"
            value="Rechercher mon trajet"
            @click="handleSubmit"
        />
      </Vuemik>
    </div>
  </div>
</template>

<script>
import TagsCategoriesPreferencesProvider from "@/providers/TagsCategoriesPreferencesProvider";
import NbStepsByDay from "@/components/Form/NbStepsByDay";
import CityChoose from "@/components/Form/CityChoose";

export default {
  name: "CityTourForm",
  inject: ["roadtrip"],
  components: {
    CityChoose,
    TagsCategoriesPreferencesProvider,
    NbStepsByDay,
  },
  mounted() {
    this.roadtrip.reset();
  }
};
</script>